//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 LightSeaGreen
#property indicator_color2 LightSeaGreen
#property indicator_color3 LightSeaGreen
#property indicator_color4 Black
#property indicator_color5 Black
#property indicator_color6 Black
#property indicator_width1 2
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 4
#property indicator_width5 3
#property indicator_width6 3
//---- indicator parameters
extern int IchiSubPeriod=20;
extern bool BolOn = true;
extern bool IchiBandOn = true;
extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BolBandsDeviations=2.0;
extern double IchiBandsDeviations=2.0;
//---- buffers
double MovingBuffer[];
double MovingBuffer2[];
double UpperBuffer[];
double LowerBuffer[];
double UpperBuffer2[];
double LowerBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
   SetIndexDrawBegin(3,BandsPeriod+BandsShift);
   SetIndexDrawBegin(4,BandsPeriod+BandsShift);
   SetIndexDrawBegin(5,BandsPeriod+BandsShift);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   if(BolOn==true)
    {
     SetIndexStyle(0,DRAW_LINE);
     SetIndexStyle(1,DRAW_LINE);
     SetIndexStyle(2,DRAW_LINE);
    }
   else
    {
     SetIndexStyle(0,DRAW_NONE);
     SetIndexStyle(1,DRAW_NONE);
     SetIndexStyle(2,DRAW_NONE);
    }
   
   SetIndexBuffer(0,MovingBuffer);
   SetIndexLabel(0,"Bolinger MA");
   SetIndexBuffer(1,UpperBuffer);
   SetIndexLabel(1,"B_Upper");
   SetIndexBuffer(2,LowerBuffer);
   SetIndexLabel(2,"B_Lower");

   if(IchiBandOn==true)
    {
     SetIndexStyle(3,DRAW_LINE);
     SetIndexStyle(4,DRAW_LINE);
     SetIndexStyle(5,DRAW_LINE);
    }
   else
    {
     SetIndexStyle(3,DRAW_NONE);
     SetIndexStyle(4,DRAW_NONE);
     SetIndexStyle(5,DRAW_NONE);
    }

   SetIndexBuffer(3,MovingBuffer2);
   SetIndexLabel(3,"Ichi MA");
   SetIndexBuffer(4,UpperBuffer2);
   SetIndexLabel(4,"IchiUpper");
   SetIndexBuffer(5,LowerBuffer2);
   SetIndexLabel(5,"IchiLower");

   int counted_bars=IndicatorCounted();
   int    i,k;
   double deviation;
   double deviation2;
   double sum,oldval,newres;
   double sum2,oldval2,newres2;
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer2[Bars-i]=EMPTY_VALUE;
         LowerBuffer2[Bars-i]=EMPTY_VALUE;
        }


//---- Tenkan Sen
   int j ,m;
   double high, low, price;
   j=Bars-BandsPeriod;

   if(counted_bars>BandsPeriod) j=Bars-counted_bars-1;
//Comment(j-1+BandsPeriod);
   while(j>=0)
     {
      high=High[j]; low=Low[j]; m=j-1+BandsPeriod;
      while(m>=j)
        {
         price=High[m];
         if(high<price) high=price;
         price=Low[m];
         if(low>price)  low=price;
         m--;
        }
      MovingBuffer2[j]=(high+low)/2;
//MovingBuffer2[j]=j;
      j--;
     }




//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      sum2=0.0;
      k=i+BandsPeriod-1;
      oldval=MovingBuffer[i];
      oldval2=MovingBuffer2[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         newres2=Close[k]-oldval2;
         sum2+=newres2*newres2;
         k--;
        }
      deviation=BolBandsDeviations*MathSqrt(sum/BandsPeriod);
      deviation2=IchiBandsDeviations*MathSqrt(sum2/BandsPeriod);
      UpperBuffer[i]=oldval+deviation;
      LowerBuffer[i]=oldval-deviation;
//      UpperBuffer2[i]=oldval2+deviation2;
//      LowerBuffer2[i]=oldval2-deviation2;
      i--;
     }


//---- Tenkan Sen UpperBuffer2
   j=Bars-BandsPeriod;

   if(counted_bars>BandsPeriod) j=Bars-counted_bars-1;
//Comment(j-1+BandsPeriod);

/*
      high=High[j]; low=Low[j]; m=j-1+BandsPeriod;
      while(m>=j)
        {
         price=High[m];
         if(high<price) high=price;
         price=Low[m];
         if(low>price)  low=price;
         m--;
        }
      MovingBuffer2[j]=(high+low)/2;
*/

   while(j>=0)
     {
//      high=UpperBuffer[j]; low=UpperBuffer[j]; m=j-1+BandsPeriod;
      high=-9999; low=9999; m=j-1+IchiSubPeriod;
      while(m>=j)
        {
         price=UpperBuffer[m];
         if(high<price) high=price;
         price=UpperBuffer[m];
         if(low>price)  low=price;
         m--;
        }
      UpperBuffer2[j]=(high+low)/2;
      j--;
     }

//---- Tenkan Sen LowerBuffer2
   j=Bars-BandsPeriod;

   if(counted_bars>BandsPeriod) j=Bars-counted_bars-1;
//Comment(j-1+BandsPeriod);
   while(j>=0)
     {
//      high=-LowerBuffer[j]; low=LowerBuffer[j]; m=j-1+BandsPeriod;
      high=-9999; low=9999; m=j-1+IchiSubPeriod;
      while(m>=j)
        {
         price=LowerBuffer[m];
         if(high<price) high=price;
         price=LowerBuffer[m];
         if(low>price)  low=price;
         m--;
        }
      LowerBuffer2[j]=(high+low)/2;
      j--;
     }


//----
   return(0);
  }
//+------------------------------------------------------------------+